<?php
class upyun{
	const END_POINT = "http://v0.api.upyun.com";
	private $bucketname;
    private $username;
    private $password;
	private $ctimeout;

	public function __construct($bucketname, $username, $password, $ctimeout){

		$this->bucketname = $bucketname;
        $this->username = $username;
        $this->password = $password;
        $this->ctimeout = $ctimeout;

	}

	public function formupload($localpath, $savepath){

		$uri = "/{$this->bucketname}";
		$date = gmdate('D, d M Y H:i:s \G\M\T');
		$options = array("bucket"=>"{$this->bucketname}", "save-key"=>$savepath, "expiration"=>time()+"{$this->ctimeout}", "date"=>$date);
		$policy = base64_encode(json_encode($options));
		$signature = base64_encode(hash_hmac("sha1", "POST&$uri&$date&$policy", md5("{$this->password}"), true));
		$header = array("Date:$date");
		if(class_exists("CURLFile")){
			$formdata = array("file"=>new CURLFile($localpath), "policy"=>$policy, "authorization"=>"UPYUN {$this->username}:$signature");
		}else{
			$formdata = array("file"=>"@$localpath", "policy"=>$policy, "authorization"=>"UPYUN {$this->username}:$signature");
		}

		$ch = curl_init(self::END_POINT.$uri);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $formdata);
		curl_exec($ch);
		$rsp_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		echo $rsp_code;

	}

}

$upyun = new upyun("", "Ա˺", "Ա", 3600);
$upyun->formupload("d:\\upstool\\13.jpg", "/999.jpg");



?>